/**
 * AP_CorrelatorInterface.hpp
 *
 * Public interface to internal correlator functions for correlator plugins.
 *
 * $Copyright(c) 2005-2006, 2008 Progress Software Corporation (PSC). All rights reserved.$
 * $Copyright (c) 2013, 2016, 2022 Software AG, Darmstadt, Germany and/or Software AG USA Inc., Reston, VA, USA, and/or its subsidiaries and/or its affiliates and/or their licensors.$
 * Use, reproduction, transfer, publication or disclosure is prohibited except as specifically provided for in your License Agreement with Software AG
 *
 */

#ifndef AP_CORRELATOR_INTERFACE_HPP
#define AP_CORRELATOR_INTERFACE_HPP

#include <AP_Platform.h>
	
class AP_CorrelatorInterface {

public:
	
	/** @deprecated
 *
	 * Send an event to the correlator
	 * 
	 * @param event the event to send.  The event is represented as a string
	 * using the format described in the Event Manager Operations manual.
	 */
	virtual void sendEvent(const char* event) const = 0;

	
protected:

	/** @deprecated
 * Destructor */
	virtual ~AP_CorrelatorInterface() { };

};


#endif // AP_CORRELATOR_INTERFACE_HPP
