/*
 * AP_PluginCommon.h
 *
 * $Copyright(c) 2002, 2004-2006, 2008-2009, 2012-2013 Progress Software Corporation (PSC). All rights reserved.$
 * $Copyright (c) 2013, 2016-2017, 2022 Software AG, Darmstadt, Germany and/or Software AG USA Inc., Reston, VA, USA, and/or its subsidiaries and/or its affiliates and/or their licensors.$
 * Use, reproduction, transfer, publication or disclosure is prohibited except as specifically provided for in your License Agreement with Software AG
 *
 */

/** @file
 * @deprecated This API is deprecated in favour of the C++ API defined in epl_plugin.hpp
 * 
 * Shared definitions for the C and C++ plugin APIs.
 */
#ifndef APAMA_PLUGIN_COMMON_H
#define APAMA_PLUGIN_COMMON_H


#define AP_PLUGIN_MAJOR_VERSION_MASK  0xffff0000
#define AP_PLUGIN_MINOR_VERSION_MASK  0x0000ffff

/** @deprecated
 *	The name of the initialization function which must be exported from a plugin library */
#define AP_INIT_FUNCTION_NAME InitLibrary
/** @deprecated
 * The name of the shutdown function which must be exported from a plugin library */
#define AP_SHUTDOWN_FUNCTION_NAME ShutdownLibrary
/** @deprecated
 * The name of the version function which must be exported from a plugin library in C++ plugins.
 * Existence of this function name determines that this is a C++ plugin not a C plugin.
 * For a C plugin use AP_PLUGIN_VERSION_FUNCTION_NAME
 */
#define AP_LIBRARY_VERSION_FUNCTION_NAME LibraryVersion
/** @deprecated
 * The name of the version function which must be exported from a plugin library in C plugins.
 * Existence of this function name determines that this is a C plugin not a C++ plugin.
 * For a C++ plugin use AP_LIBRARY_VERSION_FUNCTION_NAME
 */
#define AP_PLUGIN_VERSION_FUNCTION_NAME PluginVersion
/* @deprecated
 * The name of the capabilities function which must be exported from a plugin library.
 * optional - implement if plugins need to be able to describe their capabilities
 */
#define AP_PLUGIN_GET_CAPABILITIES_FUNCTION_NAME PluginGetCapabilities 
/* @deprecated
 * The name of the thread ended function which must be exported from a plugin library.
 * optional - implement if need to free thread local storage. Not called on shutdown and called on thread that is ending
 */
#define AP_THREAD_ENDED_FUNCTION_NAME ThreadEnded

/** @deprecated
 *
 * A typed discriminator for the contents of an AP_Type object
 */
typedef enum {
	/** @deprecated
 * No type yet (e.g. uninitialised return value) */
	AP_NULL_TYPE,			
	/** @deprecated
 * Plugin private data, opaque to EPL */
	AP_CHUNK_TYPE,
	/** @deprecated
 * EPL integer */
	AP_INTEGER_TYPE,
	/** @deprecated
 * EPL float */
	AP_FLOAT_TYPE,
	/** @deprecated
 * EPL boolean */
	AP_BOOLEAN_TYPE,
	/** @deprecated
 * EPL string */
	AP_STRING_TYPE,
	/** @deprecated
 * EPL sequence (of any supported type) */
	AP_SEQUENCE_TYPE,
	/** @deprecated
 * EPL decimal */
	AP_DECIMAL_TYPE
} AP_TypeDiscriminator;


/** @deprecated
 *
 * A typed error code discriminator
 */
typedef enum {
	/** @deprecated
 * Success */
	AP_NO_ERROR,
	/** @deprecated
 * Any other problem */
	AP_UNKNOWN_ERROR,
	/** @deprecated
 * Plugin and API versions are incompatible */
	AP_VERSION_MISMATCH_ERROR,
	AP_SERIALISATION_ERROR		// Chunk (de)serialisation failed
} AP_ErrorCode;



/** @deprecated
 *
 * Plugin capabilities.
 * these are returned OR'd together from AP_PLUGIN_GET_CAPABILITIES_FUNCTION_NAME
 */
typedef enum {
	/** @deprecated
 * none of the below capabilities */
	AP_CAPABILITIES_NONE = 0,
	/** @deprecated
 * plugin functions will not block (blocking includes calling sendEventTo) */
	AP_CAPABILITIES_NON_BLOCKING = 4
} AP_Capabilities;


#endif /* APAMA_PLUGIN_COMMON_H */
